import java.io.File;
import java.util.Iterator;
import java.util.Scanner;

/**
 * This is main class
 * 
 * @author Aditya
 * 
 */
public class CarDBMain {
	private static Scanner stdin = new Scanner(System.in);
	public static void main(String[] args) {
		// TODO: Add code for steps 1 - 3 of the main method described in the problem statement
		// display "Usage: java CarDBMain FileName" if there is not exactly one command line arguement
		
		//Check whether the input file exists and is readable; 
		//if not, display "Error: Cannot access input file" and quit.    	
    	int width = 60;//for printStar
    	try {
			//Load the data from the input file and use it to construct an car database.
			
			Scanner fileIn = new Scanner(srcFile);
			CarDB carDatabase = new CarDB();
			while(fileIn.hasNext())
			{	    		
				String[] line = fileIn.nextLine().split(",");
				double mpg = Double.parseDouble(line[0]);
				int cylinders = Integer.parseInt(line[1]);
				int power = Integer.parseInt(line[2]);
				int year = Integer.parseInt(line[3]);
				int region = Integer.parseInt(line[4]);
				String makerName = line[5].trim();
				String carName = line[6].trim();
				
				carDatabase.addCar(makerName, carName, mpg, cylinders, power, year, region);// add car
				carDatabase.addMaker(makerName);//add maker to list
				
			}	    	
		    fileIn.close();
		    boolean done = false;
		    while (!done){
		    	System.out.println("Enter option ( dlcaurmx )");
		    	String input = stdin.nextLine();
		    	try{
		    		String check = "power.mpg.year.region.cylinders";//can be used to check if the passed field is valid or not
		    		if(input.length()>0){
		    			char choice = input.charAt(0);  // strip off option character
		    			String remainder = "";  // used to hold the remainder of input
		    			if (input.length() > 1) { // if there is an argument
		    				// trim off any leading or trailing spaces
		    				remainder = input.substring(1).trim(); 

		    				switch (choice) { // the commands that have arguments
		    				case 'r': // 
		    				{
							//TODO: Fill in
					        }

					        case 'u':
					        {
							//TODO: Fill in
					        }
					        case 'c':
					        {
					        	String[] line = remainder.split(",");
							if (line.length != 3){
								System.out.println("Usage: c field,relation,value"); 					        	
								continue;
							String relations = "l.g.e";
					        	String field = line[0];
					        	String relation = line[1];
					        	String val = line[2];
					            if ((!check.contains(field)) || (!relations.contains(relation)) || (!isNumeric(val))) {
					            	System.out.println("Usage: c field,relation,value");
					            	continue;
					            }
					        	printStar(width);
					            carDatabase.selectCars(field, relation, val);
					            printStar(width);
					            break;
					        }
					        case 'a':
					        {
					            // The following code reads in a comma-separated sequence 
					            // of a string followed by an integer.  If there are not
					                // exactly six elements in the sequence or if the second
					                // element is not an integer an error message is printed.
					        	String[] line = remainder.split(",");
					            if (line.length != 7) {
					            	System.out.println("Usage: a makerName,carName,mpg,cylinders,power,year,region");
					            	continue;
					            }
					            else 
					            {
					            	if (!isNumeric(line[2]) || (!isInteger(line[3]) || (!isInteger(line[4])) || (!isInteger(line[5])) || (!isInteger(line[6])))){
					            		throw new IllegalArgumentException();
					            	}
					            	printStar(width);
					            	String makerName = line[0].trim();
					                String carName = line[1].trim();
					                double mpg = Double.parseDouble(line[2].trim());
					                int cylinders = Integer.parseInt(line[3].trim());
					                int power = Integer.parseInt(line[4].trim());
					                int year =  Integer.parseInt(line[5].trim());
					                int region																																																																						 =  Integer.parseInt(line[5].trim());
					                try{
					                	carDatabase.addCar(makerName,carName, mpg, cylinders, power, year, region);
					                } catch (Exception e){
					                	e.printStackTrace();
					                	System.out.println("Error in adding to database");
					                }


					            }
					            printStar(width);
					            break;
					        }
					        case 'l':
					        {
							//TODO: Fill in					            
					        }
					        default: // ignore any unknown commands
					        	System.out.println("Incorrect command");
					        	break;
					        
					        } // end switch
					    } // end if
					    else { //if there is no argument
					    	switch (choice) { // the commands without arguments
					    	
					    	case 'd':
					    	{
							//TODO: Fill in
					    	} 
					    	case 'm':{
					    		printStar(width);
					    		System.out.println("List of all the makers in the database: ");
					    		carDatabase.printList(carDatabase.getMakersIterator());
					    		printStar(width);
					    		break;
					    	}
					    	case 'l':
					    		System.out.println("Usage: l makerName");
					    		break;
					    	case 'c':
					    		System.out.println("Usage: c field,relation,value");
					    		break;
					    	case'a':
					    		System.out.println("Usage: a makerName,carName,mpg,cylinders,power,year,region");
					    		break;
					    	case'u':
					    		System.out.println("Usage: u name,year,field,newValue");
					    		break;
					    	case'r':
					    		System.out.println("Usage: r name,year");
					    		break;
					    	case 'x':{
					            done = true;
					            System.out.println("Exit");
					            break;
					    	}    
					    	default:  // a command with no argument
					    		System.out.println("Incorrect command");
					            break;
					    	} // end switch
					    } // end else  
                   }
		    			    	
	


		    	}catch(Exception e) {
		    		e.printStackTrace();
		    	} 
		    }
    	}catch(Exception e) {
    		e.printStackTrace();
    	}
    	
	}
	public static void printStar(int n){
		for (int i = 0; i < n ; i++) System.out.print("*");
		System.out.println("");
	}
	public static boolean isInteger(String str){//for checking Integer
		try {
			Integer.parseInt(str);
		}catch(Exception e){
			return false;
		}
		return true;
	}
	
	public static boolean isNumeric(String str)  //for checking Numeric
	{  
	  try  
	  {  
	   Double.parseDouble(str);  
	  }  
	  catch(NumberFormatException nfe)  
	  {  
	    return false;  
	  }  
	  return true;  
	}
}
